import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";

/* eslint-disable react/prop-types */
import React, { Component } from 'react';

var WithCharacterCount = function WithCharacterCount(BaseComponent) {
  var _temp;

  return _temp =
  /*#__PURE__*/
  function (_Component) {
    _inheritsLoose(_temp, _Component);

    function _temp() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _Component.call.apply(_Component, [this].concat(args)) || this;
      _this.state = {
        value: _this.props.value,
        messageAtomTextarea: '',
        initialMessageAtomTextarea: ''
      };

      _this.getHelpTextArea = function (numCharacters, maxChars) {
        var _this$props = _this.props,
            staticText = _this$props.helpText,
            _this$props$textChara = _this$props.textCharacters,
            textCharacters = _this$props$textChara === void 0 ? 'characters' : _this$props$textChara;
        var dynamicText = numCharacters + "/" + maxChars + " " + textCharacters;
        return staticText ? staticText + ' - ' + dynamicText : dynamicText;
      };

      _this.onAtomTextAreaChange = function (_ref) {
        var value = _ref.value;

        var messageAtomTextarea = _this.getHelpTextArea(value.length, _this.maxChars);

        _this.setState({
          messageAtomTextarea: messageAtomTextarea
        });
      };

      _this.handleChange = function (ev) {
        ev.persist();
        var value = ev.target.value;
        var _this$props2 = _this.props,
            onChange = _this$props2.onChange,
            maxChars = _this$props2.maxChars;
        if (value.length > maxChars) return;

        var messageAtomTextarea = _this.getHelpTextArea(value.length, maxChars);

        _this.setState({
          value: value,
          messageAtomTextarea: messageAtomTextarea
        }, function () {
          return onChange && onChange(ev, {
            value: value
          });
        });
      };

      return _this;
    }

    _temp.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, nextState) {
      if (nextProps.value === '' && nextState.value.length > 1) {
        var initialMessageAtomTextarea = nextState.initialMessageAtomTextarea;
        return {
          value: '',
          messageAtomTextarea: initialMessageAtomTextarea
        };
      }

      return null;
    };

    var _proto = _temp.prototype;

    _proto.componentDidMount = function componentDidMount() {
      var initialMessageAtomTextarea = this.initialMessageAtomTextarea;
      var messageAtomTextarea = initialMessageAtomTextarea;
      this.setState({
        messageAtomTextarea: messageAtomTextarea,
        initialMessageAtomTextarea: initialMessageAtomTextarea
      });
    };

    _proto.render = function render() {
      var _this$state = this.state,
          value = _this$state.value,
          messageAtomTextarea = _this$state.messageAtomTextarea;
      var handleChange = this.handleChange;
      return React.createElement(BaseComponent, Object.assign({}, this.props, {
        value: value,
        onChange: handleChange,
        helpText: messageAtomTextarea
      }));
    };

    _createClass(_temp, [{
      key: "initialMessageAtomTextarea",
      get: function get() {
        var _this$props3 = this.props,
            value = _this$props3.value,
            maxChars = _this$props3.maxChars;
        var lengthInitialText = value ? value.length : 0;
        return this.getHelpTextArea(lengthInitialText, maxChars);
      }
    }]);

    return _temp;
  }(Component), _temp;
};

export default WithCharacterCount;