import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import MoleculeField from '@s-ui/react-molecule-field';
import AtomTextarea, { AtomTextareaSizes as SIZES } from '@s-ui/react-atom-textarea';
import WithCharacterCount from './hoc/WithCharacterCount';
var MoleculeTextareaField = WithCharacterCount(function (_ref) {
  var id = _ref.id,
      label = _ref.label,
      maxChars = _ref.maxChars,
      textCharacters = _ref.textCharacters,
      successText = _ref.successText,
      errorText = _ref.errorText,
      helpText = _ref.helpText,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["id", "label", "maxChars", "textCharacters", "successText", "errorText", "helpText", "onChange"]);

  return React.createElement(MoleculeField, {
    name: id,
    label: label,
    textCharacters: textCharacters,
    successText: successText,
    errorText: errorText,
    helpText: helpText,
    maxChars: maxChars,
    onChange: onChange
  }, React.createElement(AtomTextarea, Object.assign({
    id: id
  }, props)));
});
MoleculeTextareaField.displayName = 'MoleculeTextareaField';
MoleculeTextareaField.defaultProps = {
  maxChars: 4000
};
export default MoleculeTextareaField;